/*	know your self
	from the others at least

	twitch like a butterfly
	in the early hours


*/


/* dcload magic value */
#define DCLOADMAGICVALUE 0xdeadbeef
#define DCLOADMAGICADDR (unsigned int *)0x8c004004

static int t=0;

static volatile struct {
	int shot;
	int player_switch;
	int player_bounce;
	int player_destroyed;
	int player_hit;
	int mine_deploy;
	int mine_pop;
	int shot_mine_hit;
	int mine_mine_hit;
	int mine_slide;
	int thrust_red;
	int thrust_blue;
	int shield_down;
	int shield_up;
	}sound;


#include <kos.h>
#include <GL/gl.h>			// Header File For The OpenGL32 Library
#include <GL/glu.h>			// Header File For The GLu32 Library
#include <math.h>
#include <stdlib.h>
#include "types.h"
#include "screenshot.c"
#include "config.c"
#include "offensives.c"
#include "replays.c"
#include "players.c"
#include "mines.c"
#include "scoreboard.c"
#include "explosions.c"
#include "arm/aica_cmd_iface.h"
#include "sound.c"
#include "trails.c"

extern uint8 romdisk[];


/* The function called when our window is resized (which shouldn't happen, because we're fullscreen) */
GLvoid ReSizeGLScene()
{
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();

  gluPerspective(45.5f,640.0f/480.0f,0.1f,30.0f);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

void initialize_players(global *g_point)
	{

	maple_rescan_bus(1);

cont_cond_t tom;

tom.buttons=~0;
tom.rtrig=0;
tom.ltrig=0;
tom.joyx=128;
tom.joyy=128;
tom.joy2x=0;
tom.joy2y=0;

g_point->A=tom;
g_point->A_old=tom;

g_point->B=tom;
g_point->B_old=tom;

g_point->C=tom;
g_point->C_old=tom;

g_point->D=tom;
g_point->D_old=tom;


	clean_trail(g_point, g_point->trails[0]);
	clean_trail(g_point, g_point->trails[1]);
	clean_trail(g_point, g_point->trails[2]);
	clean_trail(g_point, g_point->trails[3]);

g_point->mist.alpha=0.0f;
g_point->mist.red=0.0f;
g_point->mist.green=0.0f;
g_point->mist.blue=0.0f;
g_point->mist_max_a=0.5;

g_point->round_time=0;

	mine *currentm=g_point->first_mine;
	while (currentm)
			{
			mine *tmp=currentm->next;
			remove_mine(currentm, g_point);
			currentm=tmp;
			}

	offensive *currento=g_point->first_offensive;

		while (currento)
				{
				offensive *tmp=currento->next;
				remove_offensive(currento, g_point);
				currento=tmp;
				}

		offensive *currente=g_point->first_explosion;

		while (currente)
				{
				offensive *tmp=currente->next;
				remove_explosion(currente, g_point);
				currente=tmp;
				}

		while (g_point->number_of_players)
			quit_player (g_point->last_player, g_point);

		vector start1;
			start1.X=-16.0f;
			start1.Y=16.0f;

		vector start2;
			start2.X=16.0f;
			start2.Y=-16.0f;

		vector start3;
			start3.X=-16.0f;
			start3.Y=-16.0f;

		vector start4;
			start4.X=16.0f;
			start4.Y=16.0f;

if (g_point->r_control_box.status!=RECORDING)
	{
	uint8 tmp=g_point->r_control_box.replay->active_players;

	if (tmp & BLUE_P)               //Check to see if controller is in
		create_player(start1,PI*0.75,32,g_point,0.15f, 0.15f, 1.0f);

	if (tmp & RED_P)
		create_player(start2,PI*1.75,96,g_point,1.0f, 0.0f, 0.0f);


	if (tmp & GREEN_P)
		create_player(start3,PI*0.25,160,g_point,0.0f, 1.0f, 0.0f);


	if (tmp & YELLOW_P)
		create_player(start4,PI*1.25,224,g_point,1.0f, 1.0f, 0.0f);

/*controller check*/

	g_point->passive_controllers=0;


	if (cont_get_cond(32, &tom)!=0)               //Check to see if controller is in
		g_point->passive_controllers+=BLUE_P;


	if (cont_get_cond(96, &tom)!=0)               //Check to see if controller is in
		g_point->passive_controllers+=RED_P;


	if (cont_get_cond(160, &tom)!=0)               //Check to see if controller is in
		g_point->passive_controllers+=GREEN_P;



	if (cont_get_cond(224, &tom)!=0)               //Check to see if controller is in
		g_point->passive_controllers+=YELLOW_P;

	}

else
	{

	g_point->passive_controllers=0;

	if (cont_get_cond(32, &g_point->A)==0)               //Check to see if controller is in
		g_point->PA=create_player(start1,PI*0.75,32,g_point,0.15f, 0.15f, 1.0f);

	else
		g_point->passive_controllers+=BLUE_P;

	if (cont_get_cond(96, &g_point->B)==0)               //Check to see if controller is in
		g_point->PB=create_player(start2,PI*1.75,96,g_point,1.0f, 0.0f, 0.0f);

	else
		g_point->passive_controllers+=RED_P;

	if (cont_get_cond(160, &g_point->C)==0)               //Check to see if controller is in
		g_point->PC=create_player(start3,PI*0.25,160,g_point,0.0f, 1.0f, 0.0f);

	else
		g_point->passive_controllers+=GREEN_P;

	if (cont_get_cond(224, &g_point->D)==0)               //Check to see if controller is in
		g_point->PD=create_player(start4,PI*1.25,224,g_point,1.0f, 1.0f, 0.0f);

	else
		g_point->passive_controllers+=YELLOW_P;

	}
}


int main(int argc, char **argv)
{

mega3 *t1, *t2, *t3, *t4;

t1=malloc(sizeof(mega3));
t2=malloc(sizeof(mega3));
t3=malloc(sizeof(mega3));
t4=malloc(sizeof(mega3));

memset(t1, 0, sizeof(mega3));
memset(t2, 0, sizeof(mega3));
memset(t3, 0, sizeof(mega3));
memset(t4, 0, sizeof(mega3));

free (t1);
free (t2);
free (t3);
free (t4);


	kos_init_all(THD_ENABLE | IRQ_ENABLE | TA_ENABLE, ROMDISK_NONE);	// set up KOS

        glKosInit();

        glClearColor(0.0f, 0.0f, 0.0f, 0.0f);		// This Will Clear The Background Color To Black
        glShadeModel(GL_SMOOTH);			// Enables Smooth Color Shading
        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();				// Reset The Projection Matrix
		glMatrixMode(GL_MODELVIEW);

		glEnable(GL_TEXTURE_2D);
		glEnable(GL_KOS_AUTO_UV);

	global g_var;
	global *g_point=&g_var;

	g_point->demo_time=0;
	g_point->air_d=AIR_DENSITY;		//set air density (eg. resistance)
	g_point->joy_response=JOYSTICK_SENSITIVITY;			//joy response factor
	g_point->p_acceleration=PLAYER_ACCELERATION;			//acceleration factor
	g_point->number_of_players=0;
	g_point->exit_program=0;
	g_point->first_player=0;
	g_point->first_offensive=0;
	g_point->first_mine=0;
	g_point->first_explosion=0;
	g_point->max_shot_strength=160;
	g_point->shot_speed=SHOT_SPEED;
	g_point->player_start_health=PLAYER_START_HEALTH;
	g_point->assailant_earns=ASSAILANT_EARNS_HEALTH;
	g_point->shot_health_modifier=0.333;
	g_point->particle_size=PARTICLE_SIZE;
	g_point->in_menu=1;
	g_point->menu_delay=1;
	g_point->menu_controller=32;
	g_point->mine_strength=MINE_STRENGTH;
	g_point->rounds_played=0;
	g_point->sfx_lastchan=0;
	g_point->trail_length=TRAIL_LENGTH;
	g_point->trail_opasity=0.5f;
	g_point->mine_explode_push=0.03f;
	g_point->juize_increase=JUIZE_CHARGE_RATE;
	g_point->mine_countdown=MINE_COUNTDOWN;
	g_point->cost_shot=COST_SHOT;
	g_point->cost_mine=COST_MINE;
	g_point->shot_repeat_delay=SHOT_REPEAT_DELAY;
	g_point->cost_juize=COST_JUIZE;
	g_point->cost_health=COST_HEALTH;
	g_point->mist_a_decrease=MIST_A_DECREASE;
	g_point->teamplay=0;
	g_point->sound_settings=0;
	g_point->shot_player_push=0.001;
	g_point->shot_mine_push=0.002f;
	g_point->flash_intensity=0.5f;

	char b_dir[512]="/cd/";
	g_point->base_dir=b_dir;

	g_point->r_control_box.status=RECORDING;
	g_point->r_control_box.current_frame=0;
	g_point->r_control_box.replay_mode=NORMAL_REPLAY;
	g_point->r_control_box.stop_controller=32;


	g_point->trails[0]=create_trail(g_point);
	g_point->trails[1]=create_trail(g_point);
	g_point->trails[2]=create_trail(g_point);
	g_point->trails[3]=create_trail(g_point);

	void *tmp=malloc(sizeof(mega3));
	g_point->r_control_box.replay=tmp;
	g_point->r_control_box.replay->data=tmp+(sizeof(replay_header));

cont_cond_t tom;

tom.buttons=~0;
tom.rtrig=0;
tom.ltrig=0;
tom.joyx=128;
tom.joyy=128;
tom.joy2x=0;
tom.joy2y=0;

reset_scoreboard(g_point);


/*sound portion of the code*/

	uint32	hnd;

	/* Load the AICA driver */
		hnd = fs_open("/cd/snd/stream.drv", O_RDONLY);
		if (!hnd) {
			printf("Can't open sound driver\r\n");
			return -1;
		}
		streamdrv_size = fs_total(hnd);
		streamdrv = malloc(fs_total(hnd));
		fs_read(hnd, streamdrv, streamdrv_size);
		fs_close(hnd);

	spu_disable();
	spu_memset(0, 0, 0x31000);
	spu_memload(0, streamdrv, streamdrv_size);

	spu_enable();

	ram_base = ram_top = 0x31000;

sound.shot=sfx_load("/cd/snd/A_shot.wav");
sound.player_switch=sfx_load("/cd/snd/player_type_change.wav");
sound.player_bounce=sfx_load("/cd/snd/player_bounce.wav");
sound.player_hit=sfx_load("/cd/snd/player_hit.wav");
sound.mine_deploy=sfx_load("/cd/snd/mine_spawn.wav");
sound.mine_pop=sfx_load("/cd/snd/mine_pop.wav");
sound.mine_slide=sfx_load("/cd/snd/mine_slide.wav");
sound.shot_mine_hit=sfx_load("/cd/snd/shot_mine_hit.wav");
sound.mine_mine_hit=sfx_load("/cd/snd/mine_mine_hit.wav");
sound.player_destroyed=sfx_load("/cd/snd/player_destroyed.wav");
sound.shield_up=sfx_load("/cd/snd/shield_up.wav");
sound.shield_down=sfx_load("/cd/snd/shield_down.wav");

sound.thrust_red=sfx_load("/cd/snd/thrust_red.wav");
sound.thrust_blue=sfx_load("/cd/snd/thrust_blue.wav");

	/* Load a texture */

uint32 txaddr;
int w, h;

glGenTextures(NUM_TEXTURES, g_point->texture);

pcx_load_texture("/cd/gfx/zero.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[0]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/one.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[1]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/two.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[2]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/three.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[3]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/four.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[4]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/five.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[5]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/six.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[6]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/seven.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[7]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/eight.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[8]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/nine.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[9]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/scoreboard.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[SCOREBOARD]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/title.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[TITLE]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/white.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[WHITE]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/pause.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[PAUSE]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/disclaimer.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[DISCLAIMER]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/start_button.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[START_BUTTON]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/button.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[BUTTON]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/vgi.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[VGI]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);

pcx_load_texture("/cd/gfx/played.pcx", 1, 0, &txaddr, &w, &h);
glBindTexture(GL_TEXTURE_2D, g_point->texture[ROUNDS_PLAYED]);
glKosTex2D(GL_RGB565_TWID, w, h, txaddr);


recal_config(g_point);

int d=400;
float fade;

while (d>0)
	{

if (d>336)
	fade=((400.0f-(float)d)/64.0f);
else
	fade=1.0f;


if (d<64)
	fade=(float)d/64.0f;


		glKosBeginFrame();					// Tell KOS to start the frame

		glLoadIdentity();					// Reset The View

		ReSizeGLScene();  					// This isn't really a needed function...but you get the idea

		glTranslatef(0.0f,0.0f,-22.0f);
		glBindTexture(GL_TEXTURE_2D, g_point->texture[DISCLAIMER]);
 	 	glBegin(GL_QUADS);					// start drawing a polygon
 	 	glColor3f(fade,fade,fade);
  		glVertex3f(-25.6f, 28.2f, 0.0f);		// Top left
 	 	glVertex3f(25.6f, 28.2f, 0.0f);		// Top right
  		glVertex3f(25.6f,-23.0f ,0.0f);		// Bottom Right
  		glVertex3f(-25.6f,-23.0f, 0.0f);		// Bottom Left
  		glEnd();					// we're done with the polygon (smooth color interpolation)
		d--;

		glKosFinishFrame();					// Tell KOS you're done with the frame

	}

d=400;

while (d>0)
	{

if (d>336)
	fade=((400.0f-(float)d)/64.0f);
else
	fade=1.0f;


if (d<64)
	fade=(float)d/64.0f;

		glKosBeginFrame();					// Tell KOS to start the frame

		glLoadIdentity();					// Reset The View

		ReSizeGLScene();  					// This isn't really a needed function...but you get the idea

		glTranslatef(0.0f,0.0f,-22.0f);
		glBindTexture(GL_TEXTURE_2D, g_point->texture[VGI]);
 	 	glBegin(GL_QUADS);					// start drawing a polygon
 	 	glColor3f(fade,fade,fade);
  		glVertex3f(-25.6f, 24.2f, 0.0f);		// Top left
 	 	glVertex3f(25.6f, 24.2f, 0.0f);		// Top right
  		glVertex3f(25.6f,-27.0f ,0.0f);		// Bottom Right
  		glVertex3f(-25.6f,-27.0f, 0.0f);		// Bottom Left

glBindTexture(GL_TEXTURE_2D, g_point->texture[WHITE]);
  		glVertex3f(-35.6f, 24.2f, -0.1f);		// Top left
 	 	glVertex3f(15.6f, 24.2f, -0.1f);		// Top right
  		glVertex3f(15.6f,-27.0f ,-0.1f);		// Bottom Right
  		glVertex3f(-35.6f,-27.0f, -0.1f);		// Bottom Left


  		glVertex3f(-15.6f, 24.2f, -0.1f);		// Top left
 	 	glVertex3f(35.6f, 24.2f, -0.1f);		// Top right
  		glVertex3f(35.6f,-27.0f ,-0.1f);		// Bottom Right
  		glVertex3f(-15.6f,-27.0f, -0.1f);		// Bottom Left

  		glEnd();					// we're done with the polygon (smooth color interpolation)
		d--;

		glKosFinishFrame();					// Tell KOS you're done with the frame

	}


recal_replay(0, g_point);

start_replaying(ATRACTING, g_point);

while (!g_point->exit_program)
	{

g_point->A_old=g_point->A;
g_point->B_old=g_point->B;
g_point->C_old=g_point->C;
g_point->D_old=g_point->D;

if(!(g_point->passive_controllers & BLUE_P))
	cont_get_cond(32, &g_point->A);
 else
 	g_point->A=tom;

 if(!(g_point->passive_controllers & RED_P))
	cont_get_cond(96, &g_point->B);
 else
 	g_point->B=tom;

 if(!(g_point->passive_controllers & GREEN_P))
	cont_get_cond(160, &g_point->C);
 else
   g_point->C=tom;

 if(!(g_point->passive_controllers & YELLOW_P))
	cont_get_cond(224, &g_point->D);
 else
  g_point->D=tom;

		glKosBeginFrame();					// Tell KOS to start the frame
		ReSizeGLScene();  					// This isn't really a needed function...but you get the idea

switch (g_point->in_menu)
	{
	case MAIN_MENU:

	g_point->demo_time++;

	int i=600;

	if(g_point->demo_time%i==0)
		{
		if (recal_replay(g_point->demo_time/i, g_point)==-1)
			{
			g_point->demo_time=0;
			recal_replay(g_point->demo_time/i, g_point);
			}
		start_replaying(ATRACTING, g_point);
		}

		glLoadIdentity();					// Reset The View

		glTranslatef(0.0f,0.0f,-22.0f);
		glBindTexture(GL_TEXTURE_2D, g_point->texture[TITLE]);
 	 	glBegin(GL_QUADS);					// start drawing a polygon
 	 	glColor3f(1.0f,1.0f,1.0f);
  		glVertex3f( -25.1f, 26.6f, 0.0f);		// Top left
 	 	glVertex3f(25.1f, 26.6f, 0.0f);		// Top right
  		glVertex3f(25.1f,-23.6f ,0.0f);		// Bottom Right
  		glVertex3f(-25.1f,-23.6f, 0.0f);		// Bottom Left

	if ((!(g_point->A.buttons & CONT_START) && (g_point->A_old.buttons & CONT_START)) || (!(g_point->B.buttons & CONT_START) && (g_point->B_old.buttons & CONT_START)) || (!(g_point->C.buttons & CONT_START) && (g_point->C_old.buttons & CONT_START)) || (!(g_point->D.buttons & CONT_START) && (g_point->D_old.buttons & CONT_START)))
		start_recording(g_point);

	if (*DCLOADMAGICADDR == DCLOADMAGICVALUE)
		if ((!(g_point->A.buttons & CONT_Y) && (g_point->A_old.buttons & CONT_Y)) || (!(g_point->B.buttons & CONT_Y) && (g_point->B_old.buttons & CONT_Y)) || (!(g_point->C.buttons & CONT_Y) && (g_point->C_old.buttons & CONT_Y)) || (!(g_point->D.buttons & CONT_Y) && (g_point->D_old.buttons & CONT_Y)))
			g_point->exit_program=1;

break;

	case PAUSE_MENU:

	switch (g_point->menu_controller)
		{
		case 32:
			glColor3f(0.0f,0.0f,1.0f);

		if (!(g_point->A.buttons & CONT_START) && (g_point->A_old.buttons & CONT_START))
				g_point->in_menu=FALSE;

		if (!(g_point->A.buttons & CONT_B) && (g_point->A_old.buttons & CONT_B))
			{
			initialize_players(g_point);
			g_point->in_menu=MAIN_MENU;
			reset_scoreboard(g_point);
			g_point->rounds_played=0;
			stop_recording(g_point);
			}

//		if (!(g_point->A.buttons & CONT_Y) && (g_point->A_old.buttons & CONT_Y))
//			g_point->exit_program=1;

		break;

		case 96:
			glColor3f(1.0f,0.0f,0.0f);

		if (!(g_point->B.buttons & CONT_START) && (g_point->B_old.buttons & CONT_START))
				g_point->in_menu=FALSE;

		if (!(g_point->B.buttons & CONT_B) && (g_point->B_old.buttons & CONT_B))
			{
			initialize_players(g_point);
			g_point->in_menu=MAIN_MENU;
			reset_scoreboard(g_point);
			g_point->rounds_played=0;
			stop_recording(g_point);
			}

//		if (!(g_point->B.buttons & CONT_Y) && (g_point->B_old.buttons & CONT_Y))
//			g_point->exit_program=1;


		break;

		case 160:
			glColor3f(0.0f,1.0f,0.0f);


		if (!(g_point->C.buttons & CONT_START) && (g_point->C_old.buttons & CONT_START))
				g_point->in_menu=FALSE;

		if (!(g_point->C.buttons & CONT_B) && (g_point->C_old.buttons & CONT_B))
			{
			initialize_players(g_point);
			g_point->in_menu=MAIN_MENU;
			reset_scoreboard(g_point);
			g_point->rounds_played=0;
			stop_recording(g_point);
			}

//		if (!(g_point->C.buttons & CONT_Y) && (g_point->C_old.buttons & CONT_Y))
//			g_point->exit_program=1;

		break;

		case 224:
			glColor3f(1.0f, 0.85f,0.0f);

		if (!(g_point->D.buttons & CONT_START) && (g_point->D_old.buttons & CONT_START))
				g_point->in_menu=FALSE;

		if (!(g_point->D.buttons & CONT_B) && (g_point->D_old.buttons & CONT_B))
			{
			initialize_players(g_point);
			g_point->in_menu=MAIN_MENU;
			reset_scoreboard(g_point);
			g_point->rounds_played=0;
			stop_recording(g_point);
			}

//		if (!(g_point->D.buttons & CONT_Y) && (g_point->D_old.buttons & CONT_Y))
//			g_point->exit_program=1;

		break;

		default:
 		 	glColor3f(1.0f,1.0f,1.0f);
		if ((!(g_point->A.buttons & CONT_START) && (g_point->A_old.buttons & CONT_START)) || (!(g_point->B.buttons & CONT_START) && (g_point->B_old.buttons & CONT_START)) || (!(g_point->C.buttons & CONT_START) && (g_point->C_old.buttons & CONT_START)) || (!(g_point->D.buttons & CONT_START) && (g_point->D_old.buttons & CONT_START)))
				g_point->in_menu=FALSE;

		if ((!(g_point->A.buttons & CONT_B) && (g_point->A_old.buttons & CONT_B)) || (!(g_point->B.buttons & CONT_B) && (g_point->B_old.buttons & CONT_B)) || (!(g_point->C.buttons & CONT_B) && (g_point->C_old.buttons & CONT_B)) || (!(g_point->D.buttons & CONT_B) && (g_point->D_old.buttons & CONT_B)))
			{
			initialize_players(g_point);
			g_point->in_menu=MAIN_MENU;
			reset_scoreboard(g_point);
			g_point->rounds_played=0;
			stop_recording(g_point);
			}

//		if ((!(g_point->A.buttons & CONT_Y) && (g_point->A_old.buttons & CONT_Y)) || (!(g_point->B.buttons & CONT_Y) && (g_point->B_old.buttons & CONT_Y)) || (!(g_point->C.buttons & CONT_Y) && (g_point->C_old.buttons & CONT_Y)) || (!(g_point->D.buttons & CONT_Y) && (g_point->D_old.buttons & CONT_Y)))
//				g_point->exit_program=1;


		}

		glLoadIdentity();					// Reset The View
		glTranslatef(0.0f,2.0f,-22.5f);
		glBindTexture(GL_TEXTURE_2D, g_point->texture[PAUSE]);
 	 	glBegin(GL_QUADS);					// start drawing a polygon
  		glVertex3f( -10.5f, 10.5f, 0.0f);		// Top left
 	 	glVertex3f(10.5f, 10.5f, 0.0f);		// Top right
  		glVertex3f(10.5f,-10.5f ,0.0f);		// Bottom Right
  		glVertex3f(-10.5f,-10.5f, 0.0f);		// Bottom Left

		glLoadIdentity();					// Reset The View
	 	glColor3f(1.0f,1.0f,1.0f);
		glTranslatef(-2.6f,5.3,-21.9f);
		glBindTexture(GL_TEXTURE_2D, g_point->texture[START_BUTTON]);
 	 	glBegin(GL_QUADS);					// start drawing a polygon
  		glVertex3f( -1.0f, 1.0f, 0.0f);		// Top left
 	 	glVertex3f(1.0f, 1.0f, 0.0f);		// Top right
  		glVertex3f(1.0f,-1.0f ,0.0f);		// Bottom Right
  		glVertex3f(-1.0f,-1.0f, 0.0f);		// Bottom Left

	 	glColor3f(0.0f,0.0f,1.0f);
		glTranslatef(0.0f,-3.7f,0.0f);
		glBindTexture(GL_TEXTURE_2D, g_point->texture[BUTTON]);
 	 	glBegin(GL_QUADS);					// start drawing a polygon
  		glVertex3f( -1.0f, 1.0f, 0.0f);		// Top left
 	 	glVertex3f(1.0f, 1.0f, 0.0f);		// Top right
  		glVertex3f(1.0f,-1.0f ,0.0f);		// Bottom Right
  		glVertex3f(-1.0f,-1.0f, 0.0f);		// Bottom Left

	break;

	case SCOREBOARD:

	draw_scoreboard(g_point);

	glLoadIdentity();					// Reset The View

	switch (g_point->menu_controller)
		{
		case 32:
			glColor3f(0.0f,0.0f,1.0f);

		if (!(g_point->A.buttons & CONT_START) && (g_point->A_old.buttons & CONT_START))
			start_recording(g_point);

		if (!(g_point->A.buttons & CONT_X) && (g_point->A_old.buttons & CONT_X))
			store_replay(g_point);

		if (!(g_point->A.buttons & CONT_A) && (g_point->A_old.buttons & CONT_A))
			start_replaying(REVIEWING, g_point);

		break;

		case 96:
			glColor3f(1.0f,0.0f,0.0f);

		if (!(g_point->B.buttons & CONT_START) && (g_point->B_old.buttons & CONT_START))
			start_recording(g_point);

		if (!(g_point->B.buttons & CONT_X) && (g_point->B_old.buttons & CONT_X))
			store_replay(g_point);

		if (!(g_point->B.buttons & CONT_A) && (g_point->B_old.buttons & CONT_A))
			start_replaying(REVIEWING, g_point);


		break;

		case 160:
			glColor3f(0.0f,1.0f,0.0f);


		if (!(g_point->C.buttons & CONT_START) && (g_point->C_old.buttons & CONT_START))
			start_recording(g_point);

		if (!(g_point->C.buttons & CONT_X) && (g_point->C_old.buttons & CONT_X))
			store_replay(g_point);


		if (!(g_point->C.buttons & CONT_A) && (g_point->C_old.buttons & CONT_A))
			start_replaying(REVIEWING, g_point);

		break;

		case 224:
			glColor3f(1.0f, 0.85f,0.0f);

		if (!(g_point->D.buttons & CONT_START) && (g_point->D_old.buttons & CONT_START))
			start_recording(g_point);

		if (!(g_point->D.buttons & CONT_X) && (g_point->D_old.buttons & CONT_X))
			store_replay(g_point);

		if (!(g_point->D.buttons & CONT_A) && (g_point->D_old.buttons & CONT_A))
			start_replaying(REVIEWING, g_point);

		break;

		default:

 		 	glColor3f(1.0f,1.0f,1.0f);
		if ((!(g_point->A.buttons & CONT_START) && (g_point->A_old.buttons & CONT_START)) || (!(g_point->B.buttons & CONT_START) && (g_point->B_old.buttons & CONT_START)) || (!(g_point->C.buttons & CONT_START) && (g_point->C_old.buttons & CONT_START)) || (!(g_point->D.buttons & CONT_START) && (g_point->D_old.buttons & CONT_START)))
			start_recording(g_point);

		if ((!(g_point->A.buttons & CONT_X) && (g_point->A_old.buttons & CONT_X)) || (!(g_point->B.buttons & CONT_X) && (g_point->B_old.buttons & CONT_X)) || (!(g_point->C.buttons & CONT_X) && (g_point->C_old.buttons & CONT_X)) || (!(g_point->D.buttons & CONT_X) && (g_point->D_old.buttons & CONT_X)))
			store_replay(g_point);

		if ((!(g_point->A.buttons & CONT_A) && (g_point->A_old.buttons & CONT_A)) || (!(g_point->B.buttons & CONT_A) && (g_point->B_old.buttons & CONT_A)) || (!(g_point->C.buttons & CONT_A) && (g_point->C_old.buttons & CONT_A)) || (!(g_point->D.buttons & CONT_A) && (g_point->D_old.buttons & CONT_A)))
			start_replaying(REVIEWING, g_point);
		}

		glTranslatef(0.0f,23.5f,-22.1f);

	if(g_point->menu_controller>1)
		glRotatef(PI,0.0f,0.0f,1.0f);
		glBindTexture(GL_TEXTURE_2D, g_point->texture[SCOREBOARD]);

 	 	glBegin(GL_QUADS);					// start drawing a polygon
  		glVertex3f( -21.0f, 21.0f, 0.0f);		// Top left
 	 	glVertex3f(21.0f, 21.0f, 0.0f);		// Top right
  		glVertex3f(21.0f,-21.0f ,0.0f);		// Bottom Right
  		glVertex3f(-21.0f,-21.0f, 0.0f);		// Bottom Left


//draw buttons

		glLoadIdentity();					// Reset The View
	 	glColor3f(1.0f,1.0f,1.0f);
		glTranslatef(-9.75f,9.0f,-22.0f);
		glBindTexture(GL_TEXTURE_2D, g_point->texture[START_BUTTON]);

  		glVertex3f( -1.0f, 1.0f, 0.0f);		// Top left
 	 	glVertex3f(1.0f, 1.0f, 0.0f);		// Top right
  		glVertex3f(1.0f,-1.0f ,0.0f);		// Bottom Right
  		glVertex3f(-1.0f,-1.0f, 0.0f);		// Bottom Left

		glBindTexture(GL_TEXTURE_2D, g_point->texture[BUTTON]);
	 	glColor3f(1.0f,0.0f,0.0f);
		glTranslatef(3.4f,6.0f,0.0f);
		glBindTexture(GL_TEXTURE_2D, g_point->texture[BUTTON]);

  		glVertex3f( -1.0f, 1.0f, 0.0f);		// Top left
 	 	glVertex3f(1.0f, 1.0f, 0.0f);		// Top right
  		glVertex3f(1.0f,-1.0f ,0.0f);		// Bottom Right
  		glVertex3f(-1.0f,-1.0f, 0.0f);		// Bottom Left

	break;

default:
		glBindTexture(GL_TEXTURE_2D, g_point->texture[WHITE]);  //disable textures, by using an all white one

		g_point->round_time++;
		update_players (g_point);			// Update and draw the players
		update_offensives (g_point);			//uptate and draw the offensives
		update_mines(g_point);
		glKosFinishList();
		update_explosions(g_point);
		update_trails(g_point);
  		glEnd();					// we're done with the polygon (smooth color interpolation)

	int count=0;

	player *target=g_point->first_player;

	while (target)
		{
		if(target->knocked_out)
			count++;
		target=target->next;
		}

	if ((g_point->number_of_players-count)==0)
		{

		if(g_point->r_control_box.status==RECORDING)
			g_point->r_control_box.current_frame++;

		g_point->mist.red+=2*MIST_C_DECREASE;
		g_point->mist.green+=2*MIST_C_DECREASE;
		g_point->mist.blue+=2*MIST_C_DECREASE;
		g_point->mist.alpha+=1.25*g_point->mist_a_decrease;
		g_point->mist_max_a=23;

		if(!g_point->first_explosion)
			{
				g_point->menu_controller=1;
				initialize_players(g_point);
				stop_recording(g_point);
				g_point->in_menu=SCOREBOARD;
			if (g_point->r_control_box.status!=RECORDING)
				stop_replaying(g_point);
		        else
			     g_point->rounds_played++;

			}
		}

	if(g_point->number_of_players>1)
		{
		if (!g_point->first_explosion && !g_point->first_mine &&!g_point->first_offensive)
			{
			int tmp=scoreboard_add_victory(g_point);
			if (tmp)
				{
				initialize_players(g_point);
				g_point->menu_controller=tmp;
				stop_recording(g_point);
				g_point->in_menu=SCOREBOARD;
				}
			}
		}
	}
		glKosFinishFrame();					// Tell KOS you're done with the frame

	}
	return 0;
}
