player * create_player(vector position, float orientation,uint32 controller, global *g_point,float red, float green, float blue)
	{
	player *p=malloc(sizeof(player));

	/*initialize some variables to their default values*/
	p->type=BLUE;
	p->morphing=0;
	p->bouncing=0;
	p->knocked_out=0;
	p->controller=controller;
	p->health=g_point->player_start_health;
	p->speed=0;
	p->orientation=orientation;
	p->velocity.X=0;
	p->velocity.Y=0;
	p->position=position;
	p->red=red;
	p->green=green;
	p->blue=blue;
	p->button.d_up=0;
	p->button.start=1;
	p->button.a=0;
	p->button.b=0;
	p->button.x=0;
	p->button.y=0;
	p->bar_position.X=24.0f;
	p->bar_position.Y=20.0f;
	p->size=MIN_PLAYER_SIZE;
	p->collision=0;
	p->arti_countdown=0;
	p->juize=0;
	p->engine_sound=-20;
	p->shield_sound=-10;

	switch (controller)
	{
	case 32:
	p->c_input=&g_point->A;
	p->o_input=&g_point->A_old;
	break;

	case 96:
	p->c_input=&g_point->B;
	p->o_input=&g_point->B_old;
	break;

	case 160:
	p->c_input=&g_point->C;
	p->o_input=&g_point->C_old;
	break;

	case 224:
	p->c_input=&g_point->D;
	p->o_input=&g_point->D_old;
	break;

	}


	/*adjust the position of the indicator bars*/

if(g_point->number_of_players==0||g_point->number_of_players==2)
	p->bar_position.X*=-1;


if(g_point->number_of_players==2||g_point->number_of_players==3)
	p->bar_position.Y*=-1;


/*rearrange the pointers*/
	if(g_point->first_player)
		{
		p->prev=g_point->last_player;
		g_point->last_player->next=p;

		}
	else
		{
		g_point->first_player=p;
		p->prev=0;
		}

	p->next=0;
	g_point->last_player=p;
	g_point->number_of_players++;

	return p;
}

void restart_player(player *p, vector position, float orientation,global *g_point)

{
	/*initialize some variables to their default values*/
	p->type=BLUE;
	p->morphing=0;
	p->bouncing=0;
	p->knocked_out=0;
	p->health=g_point->player_start_health;
	p->speed=0;
	p->orientation=orientation;
	p->velocity.X=0;
	p->velocity.Y=0;
	p->position=position;
	p->button.d_up=0;
	p->button.start=0;
	p->button.a=0;
	p->button.b=0;
	p->bar_position.X=24.0f;
	p->bar_position.Y=20.0f;
	p->size=0.850f;
	p->collision=0;
}


void quit_player (player *quiter, global *g_point)
	{
/*typeconvert the prev and next pointers*/

	player *prev=quiter->prev;
	player *next=quiter->next;


	if (prev==0)						//if this is the first player in the row
			{
			next->prev=0;						// make the next player the first in row
			g_point->first_player=next;			//udate the global start of player list
			}
	else
		if (next==0)
				{						//if this is the last player in the row
				prev->next=0;					//make the prev player the last in row
				g_point->last_player=prev;
				}
			else
				{								//make the surrounding players point at eachother
				next->prev=quiter->prev;
				prev->next=quiter->next;
				}
	if (g_point->number_of_players==1)
		g_point->last_player=0;

free(quiter);
	g_point->number_of_players--;
	}

void update_player(player *current, global *g_point)
	{
cont_cond_t c_input=*current->c_input;
cont_cond_t o_input=*current->o_input;

player carbon;

memcpy(&carbon, current, sizeof(player));

	if (!(c_input.buttons & CONT_START) && (o_input.buttons & CONT_START))
		{
		if(g_point->r_control_box.status==RECORDING)
			{
			g_point->menu_controller=carbon.controller;
			g_point->in_menu=PAUSE_MENU;
			}
		else
			stop_replaying(g_point);
		}

if(!carbon.knocked_out)
	{
if (g_point->r_control_box.status==RECORDING)
	{
	if (!(c_input.buttons & CONT_C))
		c_input.rtrig=255;

	if (!(c_input.buttons & CONT_Z))
		c_input.ltrig=255;

	if (!(c_input.buttons & CONT_DPAD_UP))
			c_input.joyy=0;

	if (!(c_input.buttons & CONT_DPAD_DOWN))
			c_input.joyy=255;

	if (!(c_input.buttons & CONT_DPAD_LEFT))
		c_input.joyx=0;

	if (!(c_input.buttons & CONT_DPAD_RIGHT))
		c_input.joyx=255;


	store_controller(g_point, *carbon.c_input);
	}

else
	{
	if (g_point->r_control_box.current_frame>=(g_point->r_control_box.replay->length))
		stop_replaying(g_point);

	else
		{

		/*last chance to read the actual controller before we load the replay data*/
/*	if (!(c_input.buttons & CONT_Y) && (o_input.buttons & CONT_Y))
		vid_screen_shot(g_point);

	if (!(c_input.buttons & CONT_A) && (o_input.buttons & CONT_A))
		g_point->r_control_box.replay_mode=SLOW_MOTION_REPLAY;

	if (!(c_input.buttons & CONT_X) && (o_input.buttons & CONT_X))
		{
			g_point->r_control_box.replay_mode=ADVANCE_ONE_FRAME_REPLAY;
			g_point->r_control_box.stop_controller=carbon.controller;
		}


	if (!(c_input.buttons & CONT_B) && (o_input.buttons & CONT_B))
		g_point->r_control_box.replay_mode=NORMAL_REPLAY;

	int wait=0;

	switch (g_point->r_control_box.replay_mode)
		{

		case STOP_FRAME_REPLAY:

		if(carbon.controller==g_point->r_control_box.stop_controller)
			{
			while (g_point->r_control_box.replay_mode==STOP_FRAME_REPLAY)
				{

			cont_cond_t cond;

			cont_get_cond(g_point->r_control_box.stop_controller, &cond);

			while(wait<300000)
				wait++;
			wait=0;


			if (!(cond.buttons & CONT_X))
				g_point->r_control_box.replay_mode=ADVANCE_ONE_FRAME_REPLAY;

			if (!(cond.buttons & CONT_Y))
				vid_screen_shot(g_point);

			if (!(cond.buttons & CONT_A))
				g_point->r_control_box.replay_mode=SLOW_MOTION_REPLAY;

			if (!(cond.buttons & CONT_B))
				g_point->r_control_box.replay_mode=NORMAL_REPLAY;

			}
		}


		case ADVANCE_ONE_FRAME_REPLAY:
			if(carbon.controller==g_point->r_control_box.stop_controller)
			g_point->r_control_box.replay_mode=STOP_FRAME_REPLAY;
			break;

		case SLOW_MOTION_REPLAY:

			while(wait<5000000)
				wait++;
		}
*/
		if(g_point->in_menu==FALSE)
			*carbon.c_input=c_input=recal_controller(g_point);
		}

	}

	player *target=carbon.next;

	while (target)
		{
		if(!target->knocked_out)
			player_player_collision(current,target, g_point);

		target=target->next;
		}

if(!carbon.bouncing)
	{
	float Y=-(float)c_input.joyy+128.001f;   			//check for analog controller Y-axis input, typechange to float
	float X=(float)c_input.joyx-128.0f;			//read the X axis, typechange to float

	if (Y!=0)
		{
		float rad=atan2f(X,Y);

			if (rad<0)									//make sure rad stays between 0 and 2*PI
			rad=(PI2+rad);

		float length=fsqrt((X*X)+(Y*Y));			//take notice of how far the joystick is being pushed

			if ((carbon.orientation-rad)>0)				//if controller input is less than current orientation
				{
				if((carbon.orientation-rad)<PI)			//and the difference between the two is less than a half circle
					current->orientation-=(-rad+carbon.orientation)*length*g_point->joy_response*(1-carbon.speed);
				else
					current->orientation+=(-carbon.orientation+PI2+rad)*length*g_point->joy_response*(1-carbon.speed);;
				}

			else											//controller input is more than current orientation
				{
				if ((rad-carbon.orientation)<PI)			//and the difference is less than a half circle
					current->orientation+=(rad-carbon.orientation)*length*g_point->joy_response*(1-carbon.speed);

				else
					current->orientation-=(carbon.orientation+PI2-rad)*length*g_point->joy_response*(1-carbon.speed);
				}
		}

			if (current->orientation>PI2)				//Prevent overflow of orientation
				current->orientation-=PI2;

			if (current->orientation<0)					//Prevent underflow of orientation
				current->orientation+=PI2;


current->t_intensity=(float)c_input.rtrig/255.0f;


/*if there is collision this round, then let the colission routines handle movement*/

	if (carbon.collision==1)
		current->collision=0;

	else
		{
		current->speed+=(c_input.rtrig*g_point->p_acceleration)-(carbon.speed*carbon.speed*carbon.size*carbon.size*g_point->air_d)-0.0001;

		if(current->speed<0)							//prevent the current from going backwards
			current->speed=0;		//prevent the player from exceeding the maximum speed

			current->position.X-=fcos(current->orientation+PI_2)*current->speed;				//update the velocity vector
			current->position.Y+=fsin(current->orientation+PI_2)*current->speed;
		}
	}

/*end movement update*/


/*if the player is bouncing*/
else
	{
	/*update movement*/

if (current->collision==1)
		current->collision=0;

else
	{
	current->position.X+=current->velocity.X;
	current->position.Y+=current->velocity.Y;


	float rad;

	if(current->velocity.Y!=0.0f)			//atan2f is Y=zero sensitive
		{
		rad=atan2f(current->velocity.X,current->velocity.Y);
			if (rad>PI2)				//Prevent overflow of rad
				rad-=PI2;

			if (rad<=0)					//Prevent underflow of rad
				rad+=PI2;
		}

	else
		rad=current->orientation;


	float rate_of_forced_rotation=(PI*128*g_point->joy_response);

	if ((rad-current->orientation)<=0)				//if velocity direction is less than current orientation
		{
		if((current->orientation-rad)<PI)			//and the difference between the two is less than a half circle
			{

			if(current->orientation-rad<=rate_of_forced_rotation)
				{
				current->orientation=rad;
				current->bouncing=0;
				current->speed=fsqrt((current->velocity.X*current->velocity.X)+(current->velocity.Y*current->velocity.Y));
				}
			else
				current->orientation-=rate_of_forced_rotation;

			}

		else
		{
			if((PI2+rad-current->orientation)<=rate_of_forced_rotation)
				{
				current->orientation=rad;
				current->bouncing=0;
				current->speed=fsqrt((current->velocity.X*current->velocity.X)+(current->velocity.Y*current->velocity.Y));
				}

			else
				current->orientation+=rate_of_forced_rotation;

		}

	}


	else											//velocity direction is more than current orientation
		{

			if ((rad-current->orientation)<PI)			//and the difference is less than a half circle
				{
				if(rad-current->orientation<=rate_of_forced_rotation)
					{
					current->orientation=rad;
					current->bouncing=0;
					current->speed=fsqrt((current->velocity.X*current->velocity.X)+(current->velocity.Y*current->velocity.Y));
					}
				else
					current->orientation+=rate_of_forced_rotation;

				}
			else
				{
				if((PI2+current->orientation-rad)<=rate_of_forced_rotation)
					{
					current->orientation=rad;
					current->bouncing=0;
					current->speed=fsqrt((current->velocity.X*current->velocity.X)+(current->velocity.Y*current->velocity.Y));
					}
				else
					current->orientation-=rate_of_forced_rotation;
				}
			}
		}
	}

/*finished with the bouncing code */



/*button presses*/

current->size+=((float)c_input.ltrig*0.00025)-0.02f;

current->juize+=carbon.size*carbon.size*JUIZE_CHARGE_RATE;



memcpy(&carbon, current, sizeof(player));




		if (carbon.position.X>32.0f)
			current->position.X-=64.0f;
		else
		if (carbon.position.X<-32.0f)
			current->position.X+=64.0f;

		if (carbon.position.Y>24.0f)
			current->position.Y-=48.0f;
		else
		if (carbon.position.Y<-24.0f)
			current->position.Y+=48.0f;

if(carbon.engine_sound>0 && c_input.rtrig>5)
	{
//	play_sfx(sound.thrust_red, c_input.rtrig*0.5f, pos2pan(carbon.position.X), g_point);
play_sfx(sound.thrust_blue, c_input.rtrig*0.5f, pos2pan(carbon.position.X), g_point);
	current->engine_sound=-25;
	}

current->engine_sound++;

if(carbon.size<MIN_PLAYER_SIZE)
	current->size=MIN_PLAYER_SIZE;

else
	if(carbon.size>MAX_PLAYER_SIZE)
		current->size=MAX_PLAYER_SIZE;


float REZ=g_point->max_shot_strength+g_point->shot_health_modifier*(g_point->player_start_health-carbon.health);
	if (carbon.juize>REZ)
		current->juize=REZ;


	if (!(c_input.buttons & CONT_Y )&& carbon.juize>g_point->cost_health && carbon.health<g_point->player_start_health)
		{
		current->button.y++;
		current->health++;
		current->juize-=g_point->cost_health;
		current->shield_sound++;
		if(carbon.shield_sound>0)
			{
			play_sfx(sound.shield_up, 128, pos2pan(carbon.position.X), g_point);
			current->shield_sound=-25;
			}
		}

else
	if(carbon.button.y && carbon.juize>g_point->cost_health)
		{
		current->button.y=0;
		current->shield_sound=0;
		}


	if (!(c_input.buttons & CONT_X )&& carbon.health>0)
		{
		current->button.x++;
		current->health--;
		current->juize+=g_point->cost_juize;

		if(carbon.shield_sound>0)
			{
			play_sfx(sound.shield_down, 128, pos2pan(carbon.position.X), g_point);
			current->shield_sound=-30;
			}

current->shield_sound++;

		}
else
	if(carbon.button.x)
		{
		current->shield_sound=-1;
		current->button.x=0;
		}

if(carbon.button.a<0)
	current->button.a++;

else
	{
	if (!(c_input.buttons & CONT_A))
		{
		create_offensive(current, g_point,SHOT, TRUE);
		}
	}


/*mine*/

	if (!(c_input.buttons & CONT_B))
		{
		if (carbon.button.b)
			current->button.b++;
		else
			if (carbon.juize>g_point->cost_mine)
				{
				current->button.b++;
				current->juize-=g_point->cost_mine;
				}
		}
	else
		if(carbon.button.b>0)
			{
			vector tmp;
			tmp.X=-(fcos(carbon.orientation+PI_2)*carbon.speed);
			tmp.Y=(fsin(carbon.orientation+PI_2)*carbon.speed);
			current->velocity=tmp;
			create_mine(current, g_point);
			}

	}

if(!current->knocked_out)
	{


/* draw life and shot bar*/

/*shot bar*/

		float bar_length=2.4f*(float)carbon.juize/(float)g_point->max_shot_strength;

		float max_length=2.4f*(float)(g_point->max_shot_strength +g_point->shot_health_modifier*(g_point->player_start_health - carbon.health))/g_point->max_shot_strength;

		glLoadIdentity();					// Reset The View

		glTranslatef(carbon.bar_position.X,carbon.bar_position.Y,-22.5f);		// Move Left to current position And Into The Screen

 	 	glBegin(GL_QUADS);					// start drawing a polygon
 	 	glColor3f(1.0f,1.0f,1.0f);
  		glVertex3f( 0.0f, 0.0f, 0.0f);		// Top left
 	 	glVertex3f(bar_length, -0.0f,0.0f);		// Top right
  		glVertex3f(bar_length, -0.5f,0.0f);		// Bottom Right
  		glVertex3f(-0.0f,-0.5f, 0.0f);		// Bottom Left

  		glVertex3f( 0.0f, 0.0f, -0.02f);		// Top left
 	 	glVertex3f(max_length, 0.0f,-0.02f);		// Top right
  		glVertex3f(max_length, -0.5f,-0.02f);		// Bottom Right
  		glVertex3f(-0.0f,-0.5f, -0.02f);		// Bottom Left

 	 	glColor3f(0.0f,0.0f,0.0f);
  		glVertex3f( 0.1f, -0.1f, -0.01f);		// Top left
 	 	glVertex3f(max_length-0.1f, -0.1f,-0.01f);		// Top right
  		glVertex3f(max_length-0.1f, -0.4f,-0.01f);		// Bottom Right
  		glVertex3f(0.1f,-0.4f, -0.01f);		// Bottom Left

/*life bar*/

		bar_length=2.4*(float)carbon.health/(float)g_point->player_start_health;

 	 	glColor3f(carbon.red,carbon.green,carbon.blue);
  		glVertex3f(0.0f, 0.5f, 0.0f);		// Top left
 	 	glVertex3f(bar_length, 0.5f,0.0f);		// Top right
  		glVertex3f(bar_length, 0.0f,0.0f);		// Bottom Right
  		glVertex3f(-0.0f,-0.0f, 0.0f);	// Bottom Left

		glLoadIdentity();					// Reset The View
		glTranslatef(carbon.position.X,carbon.position.Y,-22.0f);		// Move Left to current position And Into The Screen

	  	glRotatef(carbon.orientation,0.0f,0.0f,1.0f);

		float f=carbon.size;

		/*make a local variable for the shield intensity*/


		float shield_intensity=(float)(carbon.health)/(float)g_point->player_start_health+0.2f;


		float f2=carbon.size-0.1-(shield_intensity/10.0f);

//draw shield

 	 	glColor3f(shield_intensity,shield_intensity,shield_intensity);

 	 	glBegin(GL_QUADS);					// start drawing a polygon

		glVertex3f( 0.0f,f2*1.0f,-0.0015f);		//12 i
		glVertex3f( 0.0f,f*1.0f,-0.0015f);		//12
 	 	glVertex3f(f*0.707106781f,f*0.707106781f,-0.0015f);	//1:30
 	 	glVertex3f(f2*0.707106781f,f2*0.707106781f,-0.0015f);	//1:30i

		glVertex3f(f2*0.707106781f,f2*0.707106781f,-0.0015f); //1:30
		glVertex3f(f*0.707106781f,f*0.707106781f,-0.0015f); //1:30
 	 	glVertex3f(f*1.0f,0.0f,-0.0015f);	//3
 	 	glVertex3f(f2*1.0f,0.0f,-0.0015f);	//3

 	 	glVertex3f(f2*1.0f,0.0f,-0.0015f);	//3
 	 	glVertex3f(f*1.0f,0.0f,-0.0015f);	//3
		glVertex3f(f*0.707106781f,f*-0.707106781f,-0.0015f); //4:30
		glVertex3f(f2*0.707106781f,f2*-0.707106781f,-0.0015f); //4:30

		glVertex3f(f2*0.707106781f,f2*-0.707106781f,-0.0015f); //4:30
		glVertex3f(f*0.707106781f,f*-0.707106781f,-0.0015f); //4:30
		glVertex3f(0.0f,f*-1.0f,-0.0015f);	//6
		glVertex3f(0.0f,f2*-1.0f,-0.0015f);	//6

		glVertex3f(0.0f,f2*-1.0f,-0.0015f);	//6
		glVertex3f(0.0f,f*-1.0f,-0.0015f);	//6
		glVertex3f(f*-0.707106781f,f*-0.707106781f,-0.0015f); //7:30
		glVertex3f(f2*-0.707106781f,f2*-0.707106781f,-0.0015f); //7:30

		glVertex3f(f2*-0.707106781f,f2*-0.707106781f,-0.0015f); //7:30
		glVertex3f(f*-0.707106781f,f*-0.707106781f,-0.0015f); //7:30
		glVertex3f(f*-1.0f,0.0f,-0.0015f);	//9
		glVertex3f(f2*-1.0f,0.0f,-0.0015f);	//9

		glVertex3f(f2*-1.0f,0.0f,-0.0015f);	//9
		glVertex3f(f*-1.0f,0.0f,-0.0015f);	//9
		glVertex3f(f*-0.707106781f,f*0.707106781f,-0.0015f); //10:30
		glVertex3f(f2*-0.707106781f,f2*0.707106781f,-0.0015f); //10:30

		glVertex3f(f2*-0.707106781f,f2*0.707106781f,-0.0015f); //10:30
		glVertex3f(f*-0.707106781f,f*0.707106781f,-0.0015f); //10:30
		glVertex3f(0.0f,f*1.0f,-0.0015f);	//12
		glVertex3f(0.0f,f2*1.0f,-0.0015f);	//12

	//draw player
 	 	glColor3f(carbon.red,carbon.green,carbon.blue);
 	 	glBegin(GL_TRIANGLES);				// start drawing a polygon
  		glVertex3f( 0.0f, 0.54f, 0.001f);		// Top
  		glVertex3f( 0.4f,-0.4f, 0.001f);		// Bottom Right
  		glVertex3f(-0.4f,-0.4f, 0.001f);		// Bottom Left




	if (carbon.button.b)
		{
		glLoadIdentity();					// Reset The View

		glTranslatef(carbon.position.X-(fsin(carbon.orientation)*(carbon.size+MINE_SIZE+0.1f)),carbon.position.Y-(fcos(carbon.orientation)*(carbon.size+MINE_SIZE+0.1f)),-22.0f);		// Move Left to current position And Into The Screen

		float size=MINE_SIZE;

 	 	glBegin(GL_QUADS);					// start drawing a polygon
  		glVertex3f(-0.5f*size, 1.0f*size, 0.01f);		// Top left
  		glVertex3f( 0.5f*size, 1.0f*size, 0.01f);		// Top right
  		glVertex3f( 1.0f*size, 0.0f*size, 0.01f);		// Bottom Right
  		glVertex3f(-1.0f*size,-0.0f*size, 0.01f);		// Bottom Left

 		glVertex3f(-1.0f*size, 0.0f*size, 0.01f);		// Top left
  		glVertex3f( 1.0f*size, 0.0f*size, 0.01f);		// Top right
  		glVertex3f( 0.5f*size, -1.0f*size, 0.01f);		// Bottom Right
  		glVertex3f(-0.5f*size,-1.0f*size, 0.01f);		// Bottom Left
		}
}

}




void update_players(global *g_point)		//calculates movement of players and collision with passives and other players,then draw
	{

	player *current=g_point->first_player;


	while (current)
			{
			update_player(current, g_point);

			current=current->next;
			}


	}

float player_player_collision(player *current, player *target, global *g_point)
{
/*collision code is almost copy'n'paste from http://www.gamasutra.com/features/20020118/vandenhuevel_02.htm*/

/*begin conversion from polar to rectangular coordinates*/

if (target->type==BLUE && !target->bouncing)
	{
	vector tmp;
	tmp.X=-(fcos(target->orientation+PI_2)*target->speed);
	tmp.Y=(fsin(target->orientation+PI_2)*target->speed);
	target->velocity=tmp;
	}

if (current->type==BLUE && !current->bouncing)
	{
	vector tmp;
	tmp.X=-(fcos(current->orientation+PI_2)*current->speed);
	tmp.Y=(fsin(current->orientation+PI_2)*current->speed);
	current->velocity=tmp;
	}

/*end conversion from polar to rectangular coordinates*/

/*distance vector between the two objects*/
vector C;
C.X=target->position.X-current->position.X;
C.Y=target->position.Y-current->position.Y;

/*velocity vector for  the relative movement of the two objects*/
vector V;
V.X=current->velocity.X-target->velocity.X;
V.Y=current->velocity.Y-target->velocity.Y;


/*early escape 1, is the relative velocity of the objects greater than the distance between them?*/

float v_length=fsqrt(V.X*V.X+V.Y*V.Y);

float sum_radi=(current->size+target->size);

float C_square=C.X*C.X+C.Y*C.Y;

if(v_length<(fsqrt(C_square)-sum_radi))
	return -1;

/*normalizing the V vector*/

vector VN;

VN.X=V.X/v_length;
VN.Y=V.Y/v_length;

float D=C.X*VN.X+C.Y*VN.Y;

if (D<0)
	return -2;

float F_square=C_square-(D*D);

float sum_radi_square=sum_radi*sum_radi;

if (F_square>sum_radi_square)
	return -3;

float T_square=sum_radi_square-F_square;

D-=fsqrt(T_square);

if (D>v_length)
	return -4;

D/=v_length;

/*update the location of the two objects to the point where they touch*/

	current->position.X+=current->velocity.X*D;
	current->position.Y+=current->velocity.Y*D;

	target->position.X+=target->velocity.X*D;
	target->position.Y+=target->velocity.Y*D;

	target->collision=1;
	current->collision=1;

/*calculate bounce*/
/*normalizing the C vector*/

vector CN;

CN.X=target->position.X-current->position.X;
CN.Y=target->position.Y-current->position.Y;


float cn_length=fsqrt(CN.X*CN.X+CN.Y*CN.Y);

CN.X/=cn_length;
CN.Y/=cn_length;

float a1=current->velocity.X*CN.X+current->velocity.Y*CN.Y;
float a2=target->velocity.X*CN.X+target->velocity.Y*CN.Y;

float optimizedP=(2.0f*(a1 - a2)) / sum_radi;

play_sfx(sound.player_bounce, optimizedP*255, pos2pan(current->position.X), g_point);

current->velocity.X-=(optimizedP * target->size * CN.X);
current->velocity.Y-=(optimizedP * target->size * CN.Y);

target->velocity.X += (optimizedP * current->size * CN.X);
target->velocity.Y += (optimizedP * current->size * CN.Y);

g_point->mist.red+=2.0;
g_point->mist.green+=2.0;
g_point->mist.blue+=2.0;
g_point->mist.alpha+=(optimizedP)*g_point->flash_intensity;

float half1=current->juize*optimizedP;
float half2=target->juize*optimizedP;

current->juize=current->juize-half1+half2;
target->juize=target->juize-half2+half1;


/*move them for the remainder of the frame along the new velocity vector*/

D=1.0f-D;

	current->position.X+=current->velocity.X*D;
	current->position.Y+=current->velocity.Y*D;

	target->position.X+=target->velocity.X*D;
	target->position.Y+=target->velocity.Y*D;

if (target->type==BLUE)
	target->bouncing=1;

if (current->type==BLUE)
	current->bouncing=1;


return 1;
}

